# /bin/sh
#
# Author: Andreas Hartmann
# andreas@hmedia.de
#
# supervises the keyboard-changer.sh
# runs every 20 minutes (via crontab)
# once there is no keyboard-changer.sh process a new one is started
# also if the keyboard-changer doesn't respond it'll be replaced
#
# check www.hmedia.de/wiki for more information
#
#

PROGRAMDIR="/site/scripts/keyboard-changer"
KEYBOARDINFDIR="/tmp/keyboard"
LOGFILE="/var/log/messages"
LOGDATE=$(date | cut -c5-19)

if ! ps -ef | cut -c 88-106 | grep -e keyboard-changer.sh > /dev/null
then
	$PROGRAMDIR/keyboard-changer.sh &
	echo "$LOGDATE localhost $(basename $0): WARN: keyboard-changer.sh does'nt run! Started a new one." >> $LOGFILE
else
	rm -f $KEYBOARDINFDIR/ping
	rm -f $KEYBOARDINFDIR/pong
	touch $KEYBOARDINFDIR/ping
	sleep 2
	if [ -f $KEYBOARDINFDIR/pong ]
	then
		rm -f $KEYBOARDINFDIR/pong
	else
		rm -f $KEYBOARDINFDIR/ping
		killall -9 keyboard-changer.sh
		$PROGRAMDIR/keyboard-changer.sh &
		echo "$LOGDATE localhost $(basename $0): ERROR: keyboard-changer.sh does'nt respond! Process killed and restarted." >> $LOGFILE
	fi
fi
