#! /bin/sh
#
# Author: Andreas Hartmann
# andreas@hmedia.de
#
# manages keyboards in according to the Hmedia ProfileManager
# runs permanentely supervised by checker.sh (via crontab)
#
# check www.hmedia.de/wiki for more information
#
#

PROGRAMDIR="/site/scripts/keyboard-changer"
KEYBOARDINFDIR="/tmp/keyboard"
LOGFILE=/var/log/messages
LOGDATE=$(date | cut -c5-19)


cd $KEYBOARDINFDIR
while true
do
	sleep 1
	for FILE in `ls`
	do
		if [ $FILE == "ping" ]
		then
			touch $KEYBOARDINFDIR/pong
			rm -f $FILE
		elif [ $FILE == "pong" ]
		then
			:
		else
			USER=`echo $FILE | cut -f 1 -d.`
			KEYBOARD=`echo $FILE | cut -f 2 -d.`
			MESSAGE=$(/exc/utraits $USER keyboard $KEYBOARD)
			rm -f $FILE
			if echo $MESSAGE | grep -E ^NO
			then
				echo "$LOGDATE localhost $(basename $0): ERROR: Can't set keyboard $KEYBOARD for $USER! User doesn't exist." >> $LOGFILE
			elif echo $MESSAGE | grep "non-numeric"
			then
				echo "$LOGDATE localhost $(basename $0): ERROR: Can't set keyboard $KEYBOARD for $USER! Keyboard must not contain non-numeric characters." >> $LOGFILE
			elif echo $MESSAGE | grep "out of range"
			then
				echo "$LOGDATE localhost $(basename $0): ERROR: Can't set keyboard $KEYBOARD for $USER! Keyboard must be within 000 to 255." >> $LOGFILE
			fi
		fi
	done
done
